org.eclipse.modisco.kdm.source.extension.discovery

## Interface ISourceRegionNotifier<T>

All Known Implementing Classes:
  AbstractDiscoverJavaModelFromProject, AbstractRegionDiscoverer2, DiscoverJavaModelFromJavaProject, DiscoverJavaModelFromProject

    public interface ISourceRegionNotifier<T>

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addSourceVisitListener(SourceVisitListener sourceVisitListener)` Add a listener to the list of listener
`java.util.List<SourceVisitListener>` `getSourceVisitListeners()` Return the list of `SourceVisitListener`s
`void` `notifySourceRegionVisited(java.lang.String filePath, int startOffset, int endOffset, EObject targetNode)` Notify all listeners that a source region has been visited This method allows not to indicate the startLine and endLine and automatically put them to -1
`void` `notifySourceRegionVisited(java.lang.String filePath, int startOffset, int endOffset, int startLine, int endLine, EObject targetNode)` Notify all listeners that a source region has been visited
`void` `removeSourceVisitListener(SourceVisitListener sourceVisitListener)` Remove the sourceVisitListener from the list of listeners

### Method Detail

#### notifySourceRegionVisited

    void notifySourceRegionVisited(java.lang.String filePath,
                                   int startOffset,
                                   int endOffset,
                                   int startLine,
                                   int endLine,
                                   EObject targetNode)

Notify all listeners that a source region has been visited

Parameters:
  `filePath` - The path of the parent compilation unit
  `startOffset` - Start offset of the source code region
  `endOffset` - End offset of the source code region
  `startLine` - First line of the source code region
  `endLine` - Last line of the source code region
  `targetNode` - The corresponding model element

#### notifySourceRegionVisited

    void notifySourceRegionVisited(java.lang.String filePath,
                                   int startOffset,
                                   int endOffset,
                                   EObject targetNode)

Notify all listeners that a source region has been visited This method allows not to indicate the startLine and endLine and automatically put them to -1

Parameters:
  `filePath` - The path of the parent compilation unit
  `startOffset` - Start offset of the source code region
  `endOffset` - End offset of the source code region
  `targetNode` - The corresponding model element

#### addSourceVisitListener

    void addSourceVisitListener(SourceVisitListener sourceVisitListener)

Add a listener to the list of listener

Parameters:
  `sourceVisitListener` -

#### removeSourceVisitListener

    void removeSourceVisitListener(SourceVisitListener sourceVisitListener)

Remove the sourceVisitListener from the list of listeners

Parameters:
  `sourceVisitListener` -

#### getSourceVisitListeners

    java.util.List<SourceVisitListener> getSourceVisitListeners()

Return the list of `SourceVisitListener`s

Returns:
  The list of `SourceVisitListener`s